/*******************************************************************************
     * File: Timer.h
     * Description: Библиотека работы с таймерами.
     * Created: 25 ноября 2016
     * Last Modifiede: 25 ноября 2016 
     * Copyright: GNU General Public License
*******************************************************************************/

/*
//TODO: Добавить комментарии.
*/

#ifndef TIMER_H_
#define TIMER_H_

//********* Функции работы с таймерами на основе millis(), micros() *********//

/// <summary>
/// Проверка таймера на основе millis
/// </summary>
uint8_t CheckTimerMillis(uint32_t PreviousTimmer, uint32_t TimeCheck);

/// <summary>
/// Проверка таймера на основе micros
/// </summary>
uint8_t CheckTimerMicros(uint32_t PreviousTimmer, uint32_t TimeCheck);

/// <summary>
/// Получение разницы между 2 uint32_t
/// </summary>
uint32_t GetDifferenceULong(uint32_t BeginTime, uint32_t EndTime);

//********* /Функции работы с таймерами на основе millis(), micros() ********//

#endif /* TIMER_H_ */
