/* 
	Editor: http://www.visualmicro.com
	        visual micro and the arduino ide ignore this code during compilation. this code is automatically maintained by visualmicro, manual changes to this file will be overwritten
	        the contents of the Visual Micro sketch sub folder can be deleted prior to publishing a project
	        all non-arduino files created by visual micro and all visual studio project or solution files can be freely deleted and are not required to compile a sketch (do not delete your own code!).
	        note: debugger breakpoints are stored in '.sln' or '.asln' files, knowledge of last uploaded breakpoints is stored in the upload.vmps.xml file. Both files are required to continue a previous debug session without needing to compile and upload again
	
	Hardware: Arduino/Genuino Mega w/ ATmega2560 (Mega 2560), Platform=avr, Package=arduino
*/

#ifndef _VSARDUINO_H_
#define _VSARDUINO_H_
#define __AVR_ATmega2560__
#define F_CPU 16000000L
#define ARDUINO 1612
#define ARDUINO_AVR_MEGA2560
#define ARDUINO_ARCH_AVR
#define __cplusplus
#define __inline__
#define __asm__(x)
#define __extension__
//#define __ATTR_PURE__
//#define __ATTR_CONST__
#define __inline__
//#define __asm__ 
#define __volatile__
#define GCC_VERSION 40801
#define volatile(va_arg) 
#define _CONST
typedef void *__builtin_va_list;
#define __builtin_va_start
#define __builtin_va_end
//#define __DOXYGEN__
#define __attribute__(x)
#define NOINLINE __attribute__((noinline))
#define prog_void
#define PGM_VOID_P int
#ifndef __builtin_constant_p
#define __builtin_constant_p __attribute__((__const__))
#endif
#ifndef __builtin_strlen
#define __builtin_strlen  __attribute__((__const__))
#endif
#define NEW_H
/*
#ifndef __ATTR_CONST__
#define __ATTR_CONST__ __attribute__((__const__))
#endif

#ifndef __ATTR_MALLOC__
#define __ATTR_MALLOC__ __attribute__((__malloc__))
#endif

#ifndef __ATTR_NORETURN__
#define __ATTR_NORETURN__ __attribute__((__noreturn__))
#endif

#ifndef __ATTR_PURE__
#define __ATTR_PURE__ __attribute__((__pure__))
#endif            
*/
typedef unsigned char byte;
extern "C" void __cxa_pure_virtual() {;}



#include <arduino.h>
#include <pins_arduino.h> 
#undef F
#define F(string_literal) ((const PROGMEM char *)(string_literal))
#undef PSTR
#define PSTR(string_literal) ((const PROGMEM char *)(string_literal))
#undef cli
#define cli()
#define pgm_read_byte(address_short)
#define pgm_read_word(address_short)
#define pgm_read_word2(address_short)
#define digitalPinToPort(P)
#define digitalPinToBitMask(P) 
#define digitalPinToTimer(P)
#define analogInPinToBit(P)
#define portOutputRegister(P)
#define portInputRegister(P)
#define portModeRegister(P)

int main(void);
//
//
void NoneMode();
void AutomaticMode();
void SemiAutomaticMode(void);
void ManualMode(void);
void DebugMode(void);
void StepCycleAddOne(void);
void StepCycleAdd(uint8_t cycleAdd);
void StepCycleSet(const STEP_CYCLE cycleSet);
void UpdateModbusData();
void Float2UInt16(float floatVal, uint16_t* uint16Array);
void Double2UInt16(double doubleVal, uint16_t* uint16Array);
void PidSetOutPut(uint8_t turningTemperatureZone, PID* pid, uint8_t pwm, uint8_t outputValue);
void PidSet(uint8_t turningTemperatureZone, uint8_t zoneNumber, PID* pid);
void PidSetTunings(uint8_t turningTemperatureZone, PID* pid, double setpoint, double input, uint8_t gapPid, uint8_t gapCheck,                    double aggKp, double aggKi, double aggKd,                    double consKp, double consKi, double consKd,                    uint8_t zoneNumber);
void ShowPinOut(uint8_t pinOut, uint8_t pinValue);
void ShowDigit(uint8_t digit, uint8_t numberDigit);
void ShowRulerRaw(uint16_t rulerValue);
void ShowMode(uint8_t mode);
void SetSingleLed(uint8_t digit);

#include <Arburg_420M_1000_250.ino>
#include <ADC.cpp>
#include <ADC.h>
#include <ADS1115.cpp>
#include <ADS1115.h>
#include <BitsMacros.h>
#include <CodeStyle.h>
#include <Config.h>
#include <Def.h>
#include <EEPROM.cpp>
#include <EEPROM.h>
#include <FastIO.h>
#include <GlobalVar.h>
#include <Max6675.cpp>
#include <Max6675.h>
#include <ModbusRtu.h>
#include <ModbusRtuSlave.cpp>
#include <ModbusRtuSlave.h>
#include <ModbusVar.h>
#include <PID.cpp>
#include <PID.h>
#include <PWM.cpp>
#include <PWM.h>
#include <Sensors.cpp>
#include <Sensors.h>
#include <TWI.cpp>
#include <TWI.h>
#include <Timer.cpp>
#include <Timer.h>
#include <Type.h>
#include <UART.cpp>
#include <UART.h>
#include <UARTDebug.cpp>
#include <UARTDebug.h>
#endif
